{
 Ŀ
  VESA INCLUDE FILE : Data types for VESA support ( July 1992 ) 
 
}

TYPE
  tPTR = RECORD             {   Type utilis pour le dcoupage des pointeurs }
           Offset,
           Segment : WORD;
         END;

VAR
  BaseEcran : Word; { Standard }

{
 Ŀ
  Fonctions supportes par VESA 1.0 
 
}
CONST
  GetCardInfo  = $4F00;
  GetModeInfo  = $4F01;
  SetVideoMode = $4F02;
  ReadCurMode  = $4F03;
  RestSaveInf  = $4F04;
  DefineWindo  = $4F05;

{
 Ŀ
  Modes vidos supports par VESA 1.0 
 
}

     _640x400x256        = $100;
     _640x480x256        = $101;
     _800x600x16         = $102;
     _800x600x256        = $103;
     _1024x768x16        = $104;
     _1024x768x256       = $105;
     _1280x1024x16       = $106;
     _1280x1024x256      = $107;


TYPE
{
 Ŀ
  Bloc d'informations VESA et SVGA renvoys par la sous-fonction 00h  
 
}
  tVESAInfo = RECORD
    Signature        : ARRAY[1..4] OF BYTE;              { toujours 'VESA' }
    VerMin,
    VerMaj           : BYTE;                           { numro de version }
    OEMNamePtr       : ^CHAR;            { pointe sur un descriptif ASCIIZ }
    RESERVED         : LONGINT;      { rserv pour une utilisation future }
    ModeListPtr : ^WORD;  { pointe sur la liste des modes vidos supports }
              END;                    { cette liste est termine par FFFFh }

    tVESAInfoPtr = ^tVESAInfo;           { Pointeur vers le bloc d'info VESA }
{
 Ŀ
  Bloc d'informations Modes Vidos renvoys par la sous-fonction 01h  
 
}
  tModeInfoBlock = RECORD
  { Informations obligatoires }
      ModeAttr         : WORD;                            { Drapeau de mode }
                                                  { bit 0 = mode possible ? }
                                 { bit 1 = information tendue disponible ? }
                              { bit 2 = fonctions BIOS texte dans ce mode ? }
                                                   { bit 3 = mode couleur ? }
                                                 { bit 4 = mode graphique ? }
                                                   { autres bits : rservs }
      FenAAttr         : BYTE;                       { Drapeau de fentre A }
                                             { bit 0 = fentre disponible ? }
                                               { bit 1 = accs en lecture ? }
                                              { bit 2 = accs en criture ? }
                                                   { autres bits : rservs }
      FenBAttr         : BYTE;                          { Drapeau fentre B }
      FenGranularity   : WORD;           { alignement minimum de la fentre }
      FenSize          : WORD;                       { taille de la fentre }
      FenASegment      : WORD;                      { adresse de la fentre }
      FenBSegment      : WORD;    { idem - n'est valide qur si la fentre B }
                                                        { existe rellement }
      FenFuncPtr       : tPTR;   { pointeur pour l'accs direct au contrle }
                                { du fentrage - plus rapide que la fonction}
                                { du BIOS }
      ByteParLigne     : WORD; { ligne logique (peut tre > ligne affiche) }

      { Informations tendues }
      XResolution      : WORD;          { en pixels si le mode est graphique }
      YResolution      : WORD;          { en caractres si le mode est texte }
      XCharSize        : BYTE;              { taille de la cellule caractre }
      YCharSize        : BYTE;
      NbrPlans         : BYTE;                     { nombre de plans de bits }
      BitsParPixel     : BYTE;                   { nombre de bits par pixels }
      NombreDeBanques  : BYTE; { contient le nombre de bancs qui contiennent }
                            { les lignes de balayage le reste de la division }
                            { ScanLine Number/Bancs donne le numro du banc  }
                            { qui contient la ligne. Le quotient donne la    }
                            { position dans la ligne.                        }

      ModeleMemoire    : BYTE;                          { 00h  :  mode texte }
                                                     { 01h  :  graphique CGA }
                                                { 02h  :  graphique Hercules }
                                                { 03h  :  planaire  4-plans }
                                                  { 04h  :  pixels compacts }
                                           { 05h  :  Non chain 4, 256 Colors }
                                               { 06h-0Fh : rserv pour VESA }
                                            { 10h-FFh : rserv constructeur }
      TailleBanque     : BYTE;  { en units de 1K, 8 pour le CGA par exemple }
                                    { seulement valable si NombreDeBancs > 1 }
                  END;                                      { tModeInfoBlock }

      tModeInfoBlockPtr = ^tModeInfoBlock;    { pointeur vers le bloc d'info }
{
 Ŀ
  BlocVESA : strucure destine  recevoir les informations VESA 
 
}
BlocVESA = ARRAY [1..256] OF BYTE;{ pour recevoir les infos des <> fonctions }

VAR
  TailleFen  : Word;           { taille de la fentre pour les accs vidos }
  Granularity: Word;
