PROGRAM VESADEMO;

USES
    Dos, Crt;
{Ŀ
  VESADEMO : Programme de dmonstration pour l'extension VESA du BIOS vido 
             Dernire rvision : juillet 1992                               
             Teste la prsence de l'extension VESA                          
             Affiche les caractristiques du BIOS VESA                      
             Essaie tous les modes vidos disponibles                       
 }

{$I VESADATA.PAS}                           { Les donnes de support de VESA }


{
 Ŀ
  WriteHexWord : cette procdure provient de l'aide de Turbo Pascal 
 
}

PROCEDURE WriteHexWord(w : WORD);
CONST
  HexChars: array [0..$F] OF Char = '0123456789ABCDEF';
BEGIN
  Write( HexChars[Hi(w) SHR 4],
         HexChars[Hi(w) AND $F],
         HexChars[Lo(w) SHR 4],
         HexChars[Lo(w) AND $F])
END;

{
Ŀ
  DisplayModeInfo : si le mode vido w est possible et s'il est possible     
  d'afficher du texte par le BIOS, place la carte dans ce mode. Au cas o le 
  mode n'est pas utilisable, reste en mode CO80. Affiche les informations    
  SVGA obligatoires et tendues si celles-ci sont disponibles.               

}
PROCEDURE DisplayModeInfo(w : WORD);
CONST
                  { Tableau reprenant les diffrents modes mmoire possibles }
  Model : ARRAY [0..5] OF STRING = (' TEXTE',' CGA 2 BLOCS',
                                    ' HERCULES 4 BLOCS',
                                    ' EGA/VGA 4 PLANS',
                                    ' EGA/VGA COMPACTE',
                                    ' EGA/VGA 256 COULEURS' );

VAR
  ModeInfo  : tModeInfoBlockPtr;
  InfoSup, SVGA : BOOLEAN;
  Regs      : Registers;
  DataVESA  : BlocVESA;
BEGIN
  Regs.AX := GetModeInfo;
  Regs.CX := w;
  Regs.ES := Seg(DataVESA);
  Regs.DI := Ofs(DataVESA);
  Intr($10,Regs);                                  { appelle la fonction 10h }

  ModeInfo := PTR(Seg(DataVESA),Ofs(DataVESA));

  ClrScr;
  DirectVideo := False;
  IF (ModeInfo^.ModeAttr AND $1) = $1
    THEN IF (ModeInfo^.ModeAttr AND $4) = $4
      THEN BEGIN
        Regs.AX := SetVideoMode;
        Regs.BX := w;
        Intr($10,Regs);
        SVGA := True;
      END;
  Write('Mode Vido : '); WriteHexWord(w); Writeln;
  Write('Attributs de mode : ');
    IF (ModeInfo^.ModeAttr AND $1) = $1 THEN Write('possible - ')
                                           ELSE Write('impossible - ');
    IF (ModeInfo^.ModeAttr AND $2) = $2 THEN InfoSup := True
                                           ELSE InfoSup := False;
    IF (ModeInfo^.ModeAttr AND $4) = $4 THEN Write('texte - ')
                                           ELSE Write('pas de texte - ');
    IF (ModeInfo^.ModeAttr AND $8) = $8 THEN Write('couleur - ')
                                           ELSE Write('monochrome - ');
    IF (ModeInfo^.ModeAttr AND $10)= $10 THEN Writeln('graphique')
                                            ELSE Writeln('texte');
  Write('Attributs de la fentre A : ');
    IF (ModeInfo^.FenAAttr AND $1) = $1 THEN Write ('disponible - ')
                                        ELSE Write ('non disponible - ');
    IF (ModeInfo^.FenAAttr AND $2) = $2 THEN Write ('lecture OK - ')
                                        ELSE Write ('pas de lecture - ');
    IF (ModeInfo^.FenAAttr AND $4) = $4 THEN Writeln ('criture OK')
                                        ELSE Writeln ('non d''criture');

  Write('Attributs de la fentre B : ');
    IF (ModeInfo^.FenBAttr AND $1) = $1 THEN Write ('disponible - ')
                                        ELSE Write ('non disponible - ');
    IF (ModeInfo^.FenBAttr AND $2) = $2 THEN Write ('lecture OK - ')
                                        ELSE Write ('pas de lecture - ');
    IF (ModeInfo^.FenBAttr AND $4) = $4 THEN Writeln ('criture OK')
                                        ELSE Writeln ('pas d''criture');

  Writeln('Granularit de la fentre : ', ModeInfo^.FenGranularity, ' K');
  Writeln('Taille de la fentre : ', ModeInfo^.FenSize, ' K');
  Write('Adresse de la fentre A : '); WriteHexWord(ModeInfo^.FenASegment);
  Writeln;
  Write('Adresse de la fentre B : '); WriteHexWord(ModeInfo^.FenBSegment);
  Writeln;

  Write('Gestion fentre en : ');
  WriteHexWord(ModeInfo^.FenFuncPtr.Segment);
  Write(':');
  WriteHexWord(ModeInfo^.FenFuncPtr.Offset);
  Writeln;

  Writeln('Nombre de byte par ligne : ', ModeInfo^.ByteParLigne);
  IF InfoSup THEN BEGIN
    Writeln;

    Writeln('Rsolution en X : ', ModeInfo^.Xresolution );
    Writeln('Rsolution en Y : ', ModeInfo^.Yresolution );

    Writeln('Largeur caractre : ', ModeInfo^.XCharSize);
    Writeln('Hauteur caractre : ', ModeInfo^.YCharSize);

    Writeln('Nombre de plans : ', ModeInfo^.NbrPlans);
    Writeln('Bits par Pixel : ', ModeInfo^.BitsParPixel);

    Writeln('Nombre de bancs : ', ModeInfo^.NombreDeBanques);
    IF ModeInfo^.NombreDeBanques <> 1
       THEN Writeln('Taille des bancs : ', ModeInfo^.TailleBanque);

    Writeln('Modle Mmoire : ', Model[ModeInfo^.ModeleMemoire]);
    END;
  Readln;
  IF SVGA = True                          { si un mode SVGA a t initialis }
    THEN BEGIN                        { alors, il faut restaurer l'affichage }
      Regs.AX := SetVideoMode; { La fonction VESA est parfaitement compatible }
      Regs.BX := $0003;       { avec les modes vido standard VGA. On remet  }
      Intr($10, Regs);        { l'cran en mode texte couleur.               }
    END;
END;

PROCEDURE TesteVESA;
VAR
  Regs     : Registers;
  VESAInfo : tVESAInfoPtr;
  DataVESA : BlocVESA;
BEGIN
  Regs.AX := GetCardInfo;                             { BIOS VESA, sous-fonction 0 }
  Regs.ES := Seg(DataVESA);    { adresse du buffer o l'on souhaite recevoir }
  Regs.DI := Ofs(DataVESA);                               { les informations }
  Intr($10,Regs);                                  { appelle la fonction 10h }

  IF Regs.AX <> $004F
    THEN BEGIN
      Writeln('L''extension BIOS VESA n''est pas installe');
      Halt(255);
    END
    ELSE Writeln('L''extension BIOS VESA est installe.');

  VESAInfo := Ptr ((Seg(DataVESA)),(Ofs(DataVESA)));
  Writeln('Signature : ', Chr(VESAInfo^.Signature[1]),
                          Chr(VESAInfo^.Signature[2]),
                          Chr(VESAInfo^.Signature[3]),
                          Chr(VESAInfo^.Signature[4]) );
  Writeln('Version du BIOS VESA ', VESAInfo^.VerMaj, '.', VESAInfo^.VerMin);
  Write('Nom de la carte : ');

  REPEAT Write(VESAInfo^.OEMNamePtr^);
         INC(VESAInfo^.OEMNamePtr);
  UNTIL (VESAInfo^.OEMNamePtr^) = #0;
  Writeln;
  Readln;
  REPEAT
    DisplayModeInfo(VESAInfo^.ModeListPtr^);
    Writeln;
    INC(VESAInfo^.ModeListPtr);
  UNTIL (VESAInfo^.ModeListPtr^) = $FFFF;
END;


BEGIN
  ClrScr;
  Writeln('');
  Writeln('Test du BIOS VESA par Pierre Vandevenne 1992');
  Writeln('');

  TesteVESA;


END.
